#include <iostream>
#include <memory>

struct animal {  // interface
	virtual void speak() const = 0;
	virtual ~animal() = default;
};

struct dog : animal {
	void speak() const override {
		std::cout << "Whoof!\n";
	}
};

struct cat : animal {
	void speak() const override {
		std::cout << "Meow!\n";
	}
};

int main() {
	// animal a;  // error
	animal* ptr;  // OK
	dog fido;
	cat felix;
	ptr = &fido;
	ptr->speak();
}
