#include <iostream>

struct example {
public: // not needed
	// everything here is public
	int x_pub = 0;
private:
	// everything here is private
	int x_priv = 1;
	void m_priv() const { std::cout << "private method\n"; }

	friend int foo(const example&);
	friend struct my_friend;
};

struct my_friend {
	int read(const example& ex) {
		ex.m_priv();
		return ex.x_priv;  // OK
	}
};

int foo(const example& ex) {
	ex.m_priv();
	return ex.x_priv;  // OK
}

void print(int x) {
	std::cout << x << '\n';
}

int main() {
	example ex;
	// ex.m_priv();               // error
	print(ex.x_pub);              // OK
	// print(ex.x_priv);          // error
	print(foo(ex));               // OK
	print(my_friend{}.read(ex));  // OK
}
