#include <iostream>
#include <string>
#include <vector>

class employee {
protected:
	int id;

private:
	int salary;

public:
	employee(int id, int salary = 0)
	  : id(id), salary(salary) {}

	void describe() const {
		std::cout << "Employee no. " << id << " with salary "
		          << salary << '\n';
	}

	friend void increase_salary(employee&, int);
};

class teacher : public employee {
	std::vector<int> courses;

public:
	teacher(int id, int salary = 0)
	  : employee(id, salary) {}
	// alternatively: using employee::employee;

	void add_course(int course_id) {
		courses.push_back(course_id);
	}

	void describe_courses() const {
		std::cout << "Teacher with employee no. " << id
		          << " teaches courses with the following ids:\n";
		for (int cid : courses) {
			std::cout << "- " << cid << '\n';
		}
	}
};

void increase_salary(employee& e, int percentage) {
	e.salary = e.salary * (100 + percentage) / 100;
}

int main() {
	employee hagrid(1, 100000);
	hagrid.describe();
	teacher snape(2, 200000);
	snape.describe();

	snape.add_course(17);
	snape.add_course(42);
	snape.describe_courses();

	employee& ref = snape;
	// ref.add_course(100);  // error
	increase_salary(snape, 10);
	ref.describe();

	employee* ptr = &snape;
	ptr->describe();
	ptr = &hagrid;
	ptr->describe();
}
